// Backlight_Level.cpp : AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "Backlight_Level.h"
#include <windows.h>
#include <commctrl.h>
#include "sysctl.h"

#define MAX_LOADSTRING 100

// O[oϐ:
HINSTANCE			g_hInst;			// ݂̃C^[tFCX
HWND				g_hWndCommandBar;	// R}h o[ nh

// ̃R[h W[Ɋ܂܂֐̐錾]܂:
ATOM			MyRegisterClass(HINSTANCE, LPTSTR);
BOOL			InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	DlgProc1(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);


int WINAPI WinMain(HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPTSTR    lpCmdLine,
                   int       nCmdShow)
{
	MSG msg;

	// AvP[V̏s܂:
	if (!InitInstance(hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	HACCEL hAccelTable;
	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_BACKLIGHT_LEVEL));

	// C bZ[W [v:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}

//
//  ֐ : MyRegisterClass()
//
//  ړI : EBhE NXo^܂B
//
//  Rg:
//
ATOM MyRegisterClass(HINSTANCE hInstance, LPTSTR szWindowClass)
{
	WNDCLASS wc;

	wc.style         = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc   = WndProc;
	wc.cbClsExtra    = 0;
	wc.cbWndExtra    = 0;
	wc.hInstance     = hInstance;
	wc.hIcon         = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_BACKLIGHT_LEVEL));
	wc.hCursor       = 0;
	wc.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName  = 0;
	wc.lpszClassName = szWindowClass;

	return RegisterClass(&wc);
}

//
//   ֐: InitInstance(HINSTANCE, int)
//
//   ړI : CX^X nhۑāAC EBhE쐬܂B
//
//   Rg:
//
//        ̊֐ŁAO[oϐŃCX^X nhۑA
//        C vO EBhE쐬ѕ\܂B
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
    HWND hWnd;
    TCHAR szTitle[MAX_LOADSTRING];		// ^Cg o[ eLXg
    TCHAR szWindowClass[MAX_LOADSTRING];	// C EBhE NX

    g_hInst = hInstance; // O[oϐɃCX^Xi[܂B


    LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING); 
    LoadString(hInstance, IDC_BACKLIGHT_LEVEL, szWindowClass, MAX_LOADSTRING);


    if (!MyRegisterClass(hInstance, szWindowClass))
    {
    	return FALSE;
    }

    hWnd = CreateWindow(szWindowClass, szTitle, WS_VISIBLE,
        CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInstance, NULL);

    if (!hWnd)
    {
        return FALSE;
    }


    ShowWindow(hWnd, nCmdShow);
    UpdateWindow(hWnd);

    if (g_hWndCommandBar)
    {
        CommandBar_Show(g_hWndCommandBar, TRUE);
    }

    return TRUE;
}

//
//  ֐: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  ړI :  C EBhẼbZ[W܂B
//
//  WM_COMMAND	- AvP[V j[̏
//  WM_PAINT	- C EBhE̕`
//  WM_DESTROY	- ~bZ[W\Ė߂
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    int wmId, wmEvent;
    PAINTSTRUCT ps;
    HDC hdc;

	
    switch (message) 
    {
        case WM_COMMAND:
            wmId    = LOWORD(wParam); 
            wmEvent = HIWORD(wParam); 
            // Iꂽj[̉:
            switch (wmId)
            {
                case IDM_HELP_ABOUT:
                    DialogBox(g_hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, About);
                    break;
                case IDM_FILE_EXIT:
                    DestroyWindow(hWnd);
                    break;
                default:
                    return DefWindowProc(hWnd, message, wParam, lParam);
            }
            break;
        case WM_CREATE:
            g_hWndCommandBar = CommandBar_Create(g_hInst, hWnd, 1);
            CommandBar_InsertMenubar(g_hWndCommandBar, g_hInst, IDR_MENU, 0);
            CommandBar_AddAdornments(g_hWndCommandBar, 0, 0);

			// ǉ@_CAO{bNX쐬܂B
			DialogBox(g_hInst, (LPCTSTR)IDD_DIALOG1, hWnd, DlgProc1);

            break;
        case WM_PAINT:
            hdc = BeginPaint(hWnd, &ps);
            
            // TODO: `R[hɒǉĂ...
            
            EndPaint(hWnd, &ps);
            break;
        case WM_DESTROY:
            CommandBar_Destroy(g_hWndCommandBar);
            PostQuitMessage(0);
            break;


        default:
            return DefWindowProc(hWnd, message, wParam, lParam);
    }
    return 0;
}

// o[W{bNX̃bZ[W nhłB
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch (message)
    {
        case WM_INITDIALOG:
            RECT rectChild, rectParent;
            int DlgWidth, DlgHeight;	// sNZPʂł̃_CAO̕ƍłB
            int NewPosX, NewPosY;

            // o[W_CAO𒆉ɂ悤ƂĂ܂B
            if (GetWindowRect(hDlg, &rectChild)) 
            {
                GetClientRect(GetParent(hDlg), &rectParent);
                DlgWidth	= rectChild.right - rectChild.left;
                DlgHeight	= rectChild.bottom - rectChild.top ;
                NewPosX		= (rectParent.right - rectParent.left - DlgWidth) / 2;
                NewPosY		= (rectParent.bottom - rectParent.top - DlgHeight) / 2;
				
                // o[W{bNXʂ傫ꍇłB 
                if (NewPosX < 0) NewPosX = 0;
                if (NewPosY < 0) NewPosY = 0;
                SetWindowPos(hDlg, 0, NewPosX, NewPosY,
                    0, 0, SWP_NOZORDER | SWP_NOSIZE);
            }
            return (INT_PTR)TRUE;

        case WM_COMMAND:
            if ((LOWORD(wParam) == IDOK) || (LOWORD(wParam) == IDCANCEL))
            {
                EndDialog(hDlg, LOWORD(wParam));
                return TRUE;
            }
            break;

        case WM_CLOSE:
            EndDialog(hDlg, message);
            return TRUE;

    }
    return (INT_PTR)FALSE;
}

// ǉ@_CAOvV[W
INT_PTR CALLBACK DlgProc1(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{	

	switch (msg) {
		case WM_INITDIALOG:
			RECT	rectChild, rectParent;
			int		DlgWidth, DlgHeight;
			POINT	NewPos;
			BYTE	level;

			if (GetWindowRect(hDlg, &rectChild)) {
				GetClientRect(GetParent(hDlg), &rectParent);
				DlgWidth	= rectChild.right  - rectChild.left;
				DlgHeight	= rectChild.bottom - rectChild.top;
				NewPos.x	= (rectParent.right  - rectParent.left - DlgWidth) / 2;
				NewPos.y	= (rectParent.bottom - rectParent.top  - DlgHeight) / 2;

				SetWindowPos (hDlg, 0, NewPos.x, NewPos.y, 0, 0, SWP_NOZORDER | SWP_NOSIZE);
			}

			// XC_[͈̔͂wiO`Tj
			SendMessage(GetDlgItem(hDlg, IDC_SLIDER1), TBM_SETRANGE, 0, (LPARAM)MAKELONG(0, 5));

			// obNCgPxx̌ݒl擾
			SysGetBacklightLevel(&level);

			// XC_[ƕ\eLXgɌݒlݒ
			SendMessage(GetDlgItem(hDlg, IDC_SLIDER1), TBM_SETPOS, (WPARAM)TRUE, (LPARAM)level);
			SetDlgItemInt(hDlg, IDC_LEVEL, (uint)level, FALSE);

			return (INT_PTR)TRUE;

		case WM_COMMAND:

			switch(LOWORD(wParam)) {
				case IDOK:
					break;

				default:
					break;
			}
			break;

		case WM_HSCROLL:
			BYTE value;

			// XC_[ωAl擾ăobNCgPxxɐݒ肷B
			if ((HWND)lParam == GetDlgItem(hDlg, IDC_SLIDER1)) {
				value = (byte)SendMessage(GetDlgItem(hDlg, IDC_SLIDER1), TBM_GETPOS, 0, 0);
				SysSetBacklightLevel(value);

				// eLXgł\
				SetDlgItemInt(hDlg, IDC_LEVEL, (uint)value, FALSE);
			}
			break;

		case WM_CLOSE:
			EndDialog(hDlg, LOWORD(wParam));
			SendMessage(GetParent(hDlg), WM_CLOSE, 0, 0);	// eEBhE閽߂𑗂܂B
			return (INT_PTR)TRUE;
	}
	return (INT_PTR)FALSE;
}