﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Opticon.Sysctl;

namespace SYSCTL_Sample
{
    public partial class Form1 : Form
    {
        Opticon.Sysctl.Backlight BKL;

        public Form1()
        {
            InitializeComponent();

            BKL = new Backlight();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            switch (BKL.Level)
            {
                case BacklightLevel.Maximum:
                    radioButton_Level5.Checked = true;
                    break;
                case BacklightLevel.Four:
                    radioButton_Level4.Checked = true;
                    break;
                case BacklightLevel.Three:
                    radioButton_Level3.Checked = true;
                    break;
                case BacklightLevel.Two:
                    radioButton_Level2.Checked = true;
                    break;
                case BacklightLevel.One:
                    radioButton_Level1.Checked = true;
                    break;
                case BacklightLevel.Minimum:
                    radioButton_Level0.Checked = true;
                    break;
            }
        }

        private void radioButton_Level5_CheckedChanged(object sender, EventArgs e)
        {
            BKL.Level = BacklightLevel.Maximum;
        }

        private void radioButton_Level4_CheckedChanged(object sender, EventArgs e)
        {
            BKL.Level = BacklightLevel.Four;
        }

        private void radioButton_Level3_CheckedChanged(object sender, EventArgs e)
        {
            BKL.Level = BacklightLevel.Three;
        }

        private void radioButton_Level2_CheckedChanged(object sender, EventArgs e)
        {
            BKL.Level = BacklightLevel.Two;
        }

        private void radioButton_Level1_CheckedChanged(object sender, EventArgs e)
        {
            BKL.Level = BacklightLevel.One;
        }

        private void radioButton_Level0_CheckedChanged(object sender, EventArgs e)
        {
            BKL.Level = BacklightLevel.Minimum;
        }
    }
}